stages:
  - build
  - test

image: rust:latest

before_script:
 - rustup component add rustfmt
 - rustup component add clippy
 - rustup show
 - apt update
 - apt-get install -y protobuf-compiler

run_cargo-fmt:
  stage: build
  script:
    - cargo fmt --verbose -- --check

run_cargo-clippy:
  stage: build
  script:
    - cargo clippy --verbose --tests -- -D warnings
  allow_failure: true

run_tests:
  stage: test
  script:
    - cargo clippy
    - cargo build --verbose
    - cargo test --verbose -- --test-threads=1
